function [f_val grad] = Obj_W_Attenuation_Group_faster(W,Xconvolved_weighted_store,Y,winsize)
% X: This is a faster version. See Compute_Convolution for X, which are original images (2D image)
% Y: Corresponding masks w.r.t X (2D image)
numFilters = size(W,1);
Sum_Xconvolved_weighted = zeros(size(Y,1)-winsize+1,size(Y,2)-winsize+1,size(Y,3));
for kk = 1:size(Y,3)
    for ii = 1:numFilters
        Sum_Xconvolved_weighted(:,:,kk) = Sum_Xconvolved_weighted(:,:,kk) + W(ii) * Xconvolved_weighted_store{1,kk}(:,:,ii);
    end
end

grad = zeros(size(W));
for kk = 1:size(Y,3)
    for ii = 1:numFilters
        grad(ii) = grad(ii) - 2 * sum(sum((Y(1+floor(winsize/2):end-floor(winsize/2),1+floor(winsize/2):end-floor(winsize/2),kk) ... 
        - Sum_Xconvolved_weighted(:,:,kk)) .* Xconvolved_weighted_store{1,kk}(:,:,ii)));
    end
end
f_val = sum(sum(sum((Y(1+floor(winsize/2):end-floor(winsize/2),1+floor(winsize/2):end-floor(winsize/2),:) - Sum_Xconvolved_weighted).^2)));